# Contributing

Thank you for wanting to contribute!

Before implementing anything major:

- For new components, [open a GitHub discussion](https://github.com/getlift/lift/discussions/categories/components) and explain the use case with an example
- For new features, [open a GitHub issue](https://github.com/getlift/lift/issues/new) and explain the use case with an example

When implementing changes, here are a few rules to follow in order to ease code reviews and merging:

- follow the coding standard by running `npm run lint` (to check) and `npm run lint:fix` (to fix the formatting)
- run the test suite: `npm run test`
- write (or update) tests when applicable
- write documentation for new features
- test your new component or feature in a real project
